﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Drawing.Imaging; // for JPG 

namespace _CaterQ_game_winForm_
{


    public partial class Form1 : Form
    {
        private List<CatQ> myCatQ = new List<CatQ>();
        private CatQ _berry = new CatQ();
        int maxWidth;
        int maxHeight;
        int u_score;
        int highScore;
        Random my_rand = new Random();
        bool goLeft, goRight, goDown, goUp;

        public Form1()
        {
            InitializeComponent();
            new drawParamS();
        }

        private void KeyIsDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Left && drawParamS.directions != "right")
            {
                goLeft = true;
            }
            if (e.KeyCode == Keys.Right && drawParamS.directions != "left")
            {
                goRight = true;
            }
            if (e.KeyCode == Keys.Up && drawParamS.directions != "down")
            {
                goUp = true;
            }
            if (e.KeyCode == Keys.Down && drawParamS.directions != "up")
            {
                goDown = true;
            }
        }

        private void KeyIsUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Left)
            {
                goLeft = false;
            }
            if (e.KeyCode == Keys.Right)
            {
                goRight = false;
            }
            if (e.KeyCode == Keys.Up)
            {
                goUp = false;
            }
            if (e.KeyCode == Keys.Down)
            {
                goDown = false;
            }
        }

        private void Go_btn_Clicked(object sender, EventArgs e)
        {
            Init_game();
        }

        private void scr_Capt(object sender, EventArgs e)
        {
            Label caption = new Label();
            caption.Text = "Your score: " + u_score + ", the Highest is " + highScore + " !";
            caption.Font = new Font("Impact", 10, FontStyle.Bold);
            caption.ForeColor = Color.Purple;
            caption.AutoSize = false;
            caption.Width = picCanvas.Width;
            caption.Height = 30;
            caption.TextAlign = ContentAlignment.MiddleCenter;
            picCanvas.Controls.Add(caption);

            SaveFileDialog dialog = new SaveFileDialog();
            dialog.FileName = "myCatQ_Shot_wow_";
            dialog.DefaultExt = "jpg";
            dialog.Filter = "JPG Image File | *.jpg";
            dialog.ValidateNames = true;

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                int width = Convert.ToInt32(picCanvas.Width);
                int height = Convert.ToInt32(picCanvas.Height);
                Bitmap bmp = new Bitmap(width, height);
                picCanvas.DrawToBitmap(bmp, new Rectangle(0,0, width, height));
                bmp.Save(dialog.FileName, ImageFormat.Jpeg);
                picCanvas.Controls.Remove(caption);
            }

        }


        private void GameTimerEvent(object sender, EventArgs e)
        {
            // setting the directions

            if (goLeft)
            {
                drawParamS.directions = "left";
            }
            if (goRight)
            {
                drawParamS.directions = "right";
            }
            if (goDown)
            {
                drawParamS.directions = "down";
            }
            if (goUp)
            {
                drawParamS.directions = "up";
            }
            // end of directions

            for (int i = myCatQ.Count - 1; i >= 0; i--)
            {
                if (i == 0)
                {

                    switch (drawParamS.directions)
                    {
                        case "left":
                            myCatQ[i].X--;
                            break;
                        case "right":
                            myCatQ[i].X++;
                            break;
                        case "down":
                            myCatQ[i].Y++;
                            break;
                        case "up":
                            myCatQ[i].Y--;
                            break;
                    }

                    if (myCatQ[i].X < 0)
                    {
                        myCatQ[i].X = maxWidth;
                    }
                    if (myCatQ[i].X > maxWidth)
                    {
                        myCatQ[i].X = 0;
                    }
                    if (myCatQ[i].Y < 0)
                    {
                        myCatQ[i].Y = maxHeight;
                    }
                    if (myCatQ[i].Y > maxHeight)
                    {
                        myCatQ[i].Y = 0;
                    }


                    if (myCatQ[i].X == _berry.X && myCatQ[i].Y == _berry.Y)
                    {
                        yumGrowCatQ();
                    }

                    for (int j = 1; j < myCatQ.Count; j++)
                    {

                        if (myCatQ[i].X == myCatQ[j].X && myCatQ[i].Y == myCatQ[j].Y)
                        {
                            Judge_LiveOrDie();
                        }

                    }


                }
                else
                {
                    myCatQ[i].X = myCatQ[i - 1].X;
                    myCatQ[i].Y = myCatQ[i - 1].Y;
                }
            }


            picCanvas.Invalidate();

        }

        private void UpdatePictureBoxGraphics(object sender, PaintEventArgs e)
        {
            Graphics canvas = e.Graphics;
            Brush snakeColour;

            for (int i = 0; i < myCatQ.Count; i++)
            {
                if (i == 0)
                {
                    snakeColour = Brushes.Brown;
                }
                else
                {
                    snakeColour = Brushes.Teal;
                }

                canvas.FillEllipse(snakeColour, new Rectangle
                    (
                    myCatQ[i].X * drawParamS.Width,
                    myCatQ[i].Y * drawParamS.Height,
                    drawParamS.Width, drawParamS.Height
                    ));
            }


            canvas.FillEllipse(Brushes.Pink, new Rectangle
            (
            _berry.X * drawParamS.Width,
            _berry.Y * drawParamS.Height,
            drawParamS.Width, drawParamS.Height
            ));
        }

        private void txtHighScore_Click(object sender, EventArgs e)
        {

        }

        private void Init_game()
        {
            maxWidth = picCanvas.Width / drawParamS.Width - 1;
            maxHeight = picCanvas.Height / drawParamS.Height - 1;

            myCatQ.Clear();

            go_Btn.Enabled = false;
            snapButton.Enabled = false;
            u_score = 0;
            txtScore.Text = "Score: " + u_score;

            CatQ head = new CatQ { X = 10, Y = 5 };
            myCatQ.Add(head); // adding the head to the Q to the LIST

            for (int i = 0; i < 10; i++)
            {
                CatQ body = new CatQ();
                myCatQ.Add(body);
            }

            _berry = new CatQ { X = my_rand.Next(2, maxWidth), Y = my_rand.Next(2, maxHeight)};

            gameTimer.Start();

        }

        private void yumGrowCatQ()
        {
            u_score += 1;

            txtScore.Text = "Your Score: " + u_score;

            CatQ body = new CatQ
            {
                X = myCatQ[myCatQ.Count - 1].X,
                Y = myCatQ[myCatQ.Count - 1].Y
            };

            myCatQ.Add(body);

            _berry = new CatQ { X = my_rand.Next(2, maxWidth), Y = my_rand.Next(2, maxHeight) };


        }

        private void Judge_LiveOrDie()
        {

            go_Btn.Enabled = true;
            snapButton.Enabled = true;

            if (u_score > highScore)
            {
                highScore = u_score;

                txtHighScore.Text = "High Score: " + Environment.NewLine + highScore;
                txtHighScore.ForeColor = Color.Maroon;
                txtHighScore.TextAlign = ContentAlignment.MiddleCenter;
            }

            gameTimer.Stop();

        }


    }
}
